#!/bin/bash
#
# *UNSET*: '<addClasspath>true</addClasspath>' and '<mainClass>com.franckbarbier.My_stack.My_stack</mainClass>' for ./My_stack.PauWare2-1.0.jar
#
clear
/usr/libexec/java_home -V
echo -e "\nJava Virtual Machine (JVM) ver.: " `java --version` " (" `which java` ")\n"
pushd . > /dev/null
cd ./exec
# Normal execution (first one doesn't work on Windows?):
#java -cp ./My_stack.PauWare2-1.0.jar:./PauWare2-1.0.jar com.franckbarbier.My_stack.My_stack
#java --module-path . --module My_stack/com.franckbarbier.My_stack.My_stack
#
# 'jlink'
#
#echo -e "\nJava linker ver.: " `/Library/Java/JavaVirtualMachines/jdk-17.jdk/Contents/Home/bin/jlink --version`
#/Library/Java/JavaVirtualMachines/jdk-17.jdk/Contents/Home/bin/jlink --module-path . --add-modules My_stack --output distribution --strip-debug --launcher My_stack=My_stack/com.franckbarbier.My_stack.My_stack
# Note: passing arguments as '--enable-preview' requires the modification of 'My_stack' as executable file:
#./distribution/bin/My_stack;rm -rf ./distribution
#
# 'jmod'
#
#echo -e "\nJava jmod ver.: " `/Library/Java/JavaVirtualMachines/jdk-17.jdk/Contents/Home/bin/jmod --version`
#mkdir ./jmod
#/Library/Java/JavaVirtualMachines/jdk-17.jdk/Contents/Home/bin/jmod create \
#--class-path ./My_stack.PauWare2-1.0.jar --main-class com.franckbarbier.My_stack.My_stack ./jmod/My_stack.jmod
# Copy dependencies to the directory where 'My_stack.jmod' is located
#cp ./PauWare2-1.0.jar ./jmod/PauWare2-1.0.jar
# Create runtime image by assembling jar and jmod files:
#/Library/Java/JavaVirtualMachines/jdk-17.jdk/Contents/Home/bin/jlink --module-path ./jmod --add-modules My_stack --output ./jmod/distribution --strip-debug --launcher My_stack=My_stack/com.franckbarbier.My_stack.My_stack
# Execution:
#./jmod/distribution/bin/My_stack;rm -rf ./jmod
#
# 'jaotc' -> code below fails since it has been removed from JDK-17:
#
echo "Ahead-Of-Time -AOT- compiler ver.: " `/Library/Java/JavaVirtualMachines/jdk-15.0.2.jdk/Contents/Home/bin/jaotc --version`
# 'PauWare2-1.0.jar' has to found be in the class path:
/Library/Java/JavaVirtualMachines/jdk-15.0.2.jdk/Contents/Home/bin/jaotc --verbose \
--output My_stack.so --jar ./My_stack.PauWare2-1.0.jar -J-cp -J./PauWare2-1.0.jar
sleep 5s
echo "Execution:"
# Execution requires metadata (namely, main class) that is available in jar files:
java -cp ./My_stack.PauWare2-1.0.jar:./PauWare2-1.0.jar -verbose:module \
-XX:+UnlockExperimentalVMOptions -XX:AOTLibrary=My_stack.so -XX:+PrintAOT com.franckbarbier.My_stack.My_stack
popd > /dev/null